---
source_url: https://www.pubnub.com/docs/sdks/rest-api/send-signal-to-channel
title: Send signal to channel
---

# Send signal to channel

> For AI agents: documentation index at https://www.pubnub.com/llms-full.txt

This resource allows a developer to send a [signal](https://www.pubnub.com/docs/pub-sub/publish/overview.md) to a channel.

Returns a three-element array:

* Array element 0 - (Integer) `1` or `0`, where `1` is a success, and `0` is an error.
* Array element 1 - (String) Description of the success or error, if available.
* Array element 2 - (String) The current PubNub time expressed as a timetoken.

| Path Parameters |
| --- |
| `pub_key`string—**REQUIRED**You app’s publish key from Admin Portal.Example: pub-c-50264475-1902-558x-b37b-56d7fb64bf45 |
| `sub_key`string—**REQUIRED**Your app's subscribe key from Admin Portal.Example: sub-c-50264475-1902-558x-d213-7p19052012n2 |
| `channel`string—**REQUIRED**The channel ID to perform the operation on.Example: myChannel |
| `callback`string—**REQUIRED**The JSONP callback name to wrap the function in. Use 0 for no callback.Example (myCallback): myCallbackExample (zero): 0 |
| `payload`string—**REQUIRED**Signals are limited to a message payload size of 64 bytes. This limit applies only to the request body, not to the URI or headers. |

| Query Parameters |
| --- |
| `uuid`stringA UTF-8 encoded string of up to 92 characters used to identify the client.Example: myUniqueUserId |
| `auth`stringString which is either the auth key (Access Manager legacy) or a valid token (Access Manager) used to authorize the operation if access control is enabled.Example: myAuthKey |
| `signature`stringSignature used to verify that the request was signed with the secret key associated with the subscribe key.If Access Manager is enabled, either a valid authorization token or a signature are required. Check Access Manager documentation for details on how to compute the signature. |
| `timestamp`integerUnix epoch timestamp used as a nonce for signature computation. Must have no more than ± 60 seconds offset from NTP.Required if the signature parameter is supplied. |
| `custom_message_type`stringPossible values: 3 ≤ length ≤ 50User-specified message type string - limited by 3-50 case-sensitive alphanumeric characters with only - and _ special characters allowed.[a-zA-Z0-9-_*] |

| Responses |
| --- |
| `200`Publish successfulSchema — OPTIONAL undefined[] | Schema—**OPTIONAL** | undefined[] |
| Schema—**OPTIONAL** |
| undefined[] |
| `400`Bad RequestSchema — OPTIONAL undefined[] | Schema—**OPTIONAL** | undefined[] |
| Schema—**OPTIONAL** |
| undefined[] |
| `403`Unauthorized accessSchema — OPTIONALmessage string — OPTIONALpayload object — OPTIONALchannels string[] — OPTIONALerror boolean — OPTIONALservice string — OPTIONALstatus integer — OPTIONAL | Schema—**OPTIONAL** | `message`string—**OPTIONAL** | `payload`object—**OPTIONAL**channels string[] — OPTIONAL | `channels`string[]—**OPTIONAL** | `error`boolean—**OPTIONAL** | `service`string—**OPTIONAL** | `status`integer—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `message`string—**OPTIONAL** |
| `payload`object—**OPTIONAL**channels string[] — OPTIONAL | `channels`string[]—**OPTIONAL** |
| `channels`string[]—**OPTIONAL** |
| `error`boolean—**OPTIONAL** |
| `service`string—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `413`Signal payload size is too large (>=32KiB)Schema — OPTIONALstatus integer — OPTIONALservice string — OPTIONALerror boolean — OPTIONALmessage string — OPTIONAL | Schema—**OPTIONAL** | `status`integer—**OPTIONAL** | `service`string—**OPTIONAL** | `error`boolean—**OPTIONAL** | `message`string—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `service`string—**OPTIONAL** |
| `error`boolean—**OPTIONAL** |
| `message`string—**OPTIONAL** |
| `429`Request rate limit exceededSchema — OPTIONALstatus integer — OPTIONALerror boolean — OPTIONALmessage string — OPTIONAL | Schema—**OPTIONAL** | `status`integer—**OPTIONAL** | `error`boolean—**OPTIONAL** | `message`string—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `error`boolean—**OPTIONAL** |
| `message`string—**OPTIONAL** |

pub_key
*
Type:
string
You app’s publish key from
[Admin Portal](https://admin.pubnub.com)
.
sub_key
*
Type:
string
Your app's subscribe key from
[Admin Portal](https://admin.pubnub.com)
.
channel
*
Type:
string
The channel ID to perform the operation on.
callback
*
Type:
string
The JSONP callback name to wrap the function in. Use
0
for no callback.
payload
*
Type:
string
Signals are limited to a message payload size of 64 bytes.  This limit applies only to the request body, not to the URI or headers.
uuid
Type:
string
A UTF-8 encoded string of up to 92 characters used to
[identify the client](https://www.pubnub.com/docs/architecture/core-concepts.md)
.
auth
Type:
string
String which is either the auth key (Access Manager legacy) or a valid token (
[Access Manager](https://www.pubnub.com/docs/security/access-control/overview.md)
) used to authorize the operation if access control is enabled.
signature
Type:
string
Signature used to verify that the request was signed with the secret key associated with the subscribe key.

If Access Manager is enabled, either a valid authorization token or a signature are required.

Check
[Access Manager documentation](https://www.pubnub.com/docs/sdks/rest-api/access-manager-introduction.md)
for details on how to compute the signature.
timestamp
Type:
integer
Unix epoch timestamp used as a nonce for signature computation. Must have no more than ± 60 seconds offset from NTP.

Required if the
signature
parameter is supplied.
custom_message_type
Type:
string
User-specified message type string - limited by 3-50 case-sensitive alphanumeric characters with only
-
and
_
special characters allowed.

[a-zA-Z0-9-_*]
Example Response

```
[
  1,
  "Sent",
  "14375220012064619"
]
```

Example Response

```
[
  0,
  "Wildcard maximum depth exceeded",
  "16866840224081436"
]
```
